(*
 * Alessandro Baretta
 * Studio Baretta
 * http://studio.baretta.com/
 *)




let (++) x f = f x

module Q = struct
  type 'a queue = 'a list * 'a list

  exception Is_empty

  let empty = [], []
  let is_empty (f, r) = f = []
			    
  let checkf = function
    | ([] as front ,rear) -> List.rev rear, front
    | q -> q 
  let make l = (l, [])
  let add x (front, rear) = checkf (front, x :: rear)
  let top = function
    | hd :: tl, _ -> hd
    | _ -> raise Is_empty

  let pop = function
    | hd :: tl, l2 -> checkf (tl, l2)
    | _ -> raise Is_empty
end

type color =  B | R | Y
type live_chameneos = {
  color : color;
  meeting_count : int;
}
type faded_chameneos = int

let compl c1 c2 = match c1, c2 with
  | B, B -> B | R, R -> R | Y, Y -> Y
  | B, R | R, B -> Y   | B, Y | Y, B -> R   | R, Y | Y, R -> B


let fade ch : faded_chameneos = ch.meeting_count

let requested_meeting_count = int_of_string Sys.argv.(1)

let rec meeting_phase (queue : live_chameneos Q.queue) meeting_point meeting_count =
  if meeting_count < requested_meeting_count then
    match meeting_point with
      | None -> meeting_phase (Q.pop queue) (Some (Q.top queue)) meeting_count
      | Some ch1 ->
          let ch2 = Q.top queue in
          let color = compl ch1.color ch2.color in
          let queue' =  queue ++ Q.pop
            ++ (Q.add { color = color; meeting_count = succ ch1.meeting_count})
            ++ (Q.add { color = color; meeting_count = succ ch2.meeting_count})
          in meeting_phase queue' None (succ meeting_count)
  else begin
    assert(meeting_point = None);
    fading_phase queue [] 0
  end

and fading_phase queue faded_chameneos reported_meetings =
  if Q.is_empty queue then reported_meetings else
    let ch = Q.top queue in
      fading_phase (Q.pop queue) ((fade ch)::faded_chameneos) (reported_meetings + ch.meeting_count)

let ch = { color = B; meeting_count = 0 }
let ch_list = [ ch; { ch with color = R }; { ch with color = Y }; ch ] 

let res = meeting_phase (Q.make ch_list) None 0 

let () = print_int res; print_newline ()
